//===========================================================================
//
// Generator.h
//
// By Poman So
//
//===========================================================================

#ifndef _Generator_h_
#define _Generator_h_

#include "GUI.h"
#include "Const.h"


//---------------------------------------------------------------------------
//
//	Generator Class
//
//---------------------------------------------------------------------------
class Generator: public DTaskWindow{
	RadioBox fieldbox;
	RadioBox distbox;
	ListBox  function;
	GraphBox graphbox;
	Boolean	 connected;
	int	 fb_statebits;
	int	 db_statebits;
	float	 amplitude,frequency,period;	// All functions
	float	 sigma,mean;			// Gaussian function
	float	 rise_t,fall_t;			// NEMP
static	float	Dt;
	int	fb_highlighted;
	int	px1();
	int	py1();
	int	px2();
	int	py2();
	void	DrawGraph();
	Status	ImpulseP();
	Status	GaussianP();
	Status	RCosP();
	Status	SinP();
	Status	SquareP();
	Status	TriP();
	Status	NEMP();
	Status	Sinf();
	Status	Squaref();
	Status	Trif();
	void	Function();
	void	ExposeCB();
	void	Dt_CB();
public:
	Generator(Window &w, char *label, Generator *G=0);
	Status	  WindowCB(CBTag tag);
	Status	  ChildCB(Window *w, CBTag tag);
	fstream   &IO(fstream &fs);
	Generator *Previous(){return (Generator*)previous;}
	Generator *Next(){return (Generator*)next;}
	Boolean   Connected(){return connected;}
	void	  Connect(Boolean c=True){connected=c;}
	float	  ModTwoPi(float f){return (f<TWOPI)?f:f-int(f/TWOPI)*TWOPI;}
	float	  ImpulseP(int n);
	float	  GaussianP(int n);
	float	  RCosP(int n);
	float	  SinP(int n);
	float	  SquareP(int n);
	float	  TriP(int n);
	float	  NEMP(int n);
	float	  Sinf(int n);
	float	  Squaref(int n);
	float	  Trif(int n);
	float	  Function(int n);
	int	  FieldMode();
	int	  DistMode();
};//--- Generator ---//



#endif

//===========================================================================
//
// End of Generator.h
//
//===========================================================================
