//===========================================================================
//
// IntN.h
//
// By Poman So
//
//===========================================================================

#ifndef _IntN_h_
#define _IntN_h_

#include "Real.h"

//---------------------------------------------------------------------------
//
//	Integer Cartesian Co-ordinate Class
//
//---------------------------------------------------------------------------
class Int2{
public:
	int x,y;
	
	Int2();
	Int2(Real a, Real b);
	int   X(){return x;}
	int   Y(){return y;}
	Int2  operator+ (const Int2& a);
	Int2& operator+=(const Int2& c);
	Int2  operator- (const Int2& a);
	Int2& operator-=(const Int2& c);
	Int2  operator/ (const Int2& a);
	Int2  operator/ (Real a);
	Int2& operator/=(Real a);
	Int2  operator* (const Int2& a);
	Int2  operator* (Real a);
	Int2& operator*=(Real a);
	int   operator==(const Int2& a);
	int   operator!=(const Int2& a);
	Int2& operator=(const Int2& a);
};//--- Int2 ---//
Int2  operator* (Real a, Int2& b);
Int2  Min(const Int2& a, const Int2& b);
Int2  Max(const Int2& a, const Int2& b);


//---------------------------------------------------------------------------
//
//	Int4 Class
//
//---------------------------------------------------------------------------
class Int4{
public:
	Int2 p1,p2;
	Int4();
	Int4(Int2 P1,Int2 P2);
	Int4(Real x1, Real y1, Real x2, Real y2);
	Int2 P1();
	Int2 P2();
	Int4& operator=(const Int4& a);
	int   Okay();
	int   Intersect(const Int4 &a, Int4 &b);
	int   Different(const Int4 &a, Int4 *b);
};//--- Int4 ---//
Int4  Min(const Int4& a, const Int4& b);
Int4  Max(const Int4& a, const Int4& b);



#endif


//===========================================================================
//
// End of IntN.h
//
//===========================================================================
